--- cgi-bin/openwebmail/openwebmail-prefs.pl	Tue Apr 13 13:30:17 2004
+++ cgi-bin/openwebmail/openwebmail-prefs.pl	Tue Apr 13 20:14:49 2004
@@ -964,6 +964,105 @@
             templateblock_disable($html, 'FILTER');
          }
 
+         if ($config{'enable_spamassassin'}) {
+            templateblock_enable($html, 'SPAMASSASSIN');
+
+            $temphtml = checkbox(-name=>'sa_enable',
+                                 -value=>'1',
+                                 -checked=>$prefs{'sa_enable'},
+                                 -label=>'',
+                                 defined($config_raw{'DEFAULT_sa_enable'})?('-disabled'=>'1'):());
+            $html =~ s/\@\@\@SPAMASSASSINENABLE\@\@\@/$temphtml/;
+
+            if ($config{'sa_enable_bayesian'}) {
+               templateblock_enable($html, 'SPAMASSASSINBAYESIAN');
+               $temphtml = checkbox(-name=>'sa_use_bayes',
+                                    -value=>'1',
+                                    -checked=>$prefs{'sa_use_bayes'},
+                                    -label=>'',
+                                    defined($config_raw{'DEFAULT_sa_use_bayes'})?('-disabled'=>'1'):());
+               $html =~ s/\@\@\@SPAMASSASSINUSEBAYES\@\@\@/$temphtml/;
+
+               $temphtml = checkbox(-name=>'sa_bayes_auto_learn',
+                                    -value=>'1',
+                                    -checked=>$prefs{'sa_bayes_auto_learn'},
+                                    -label=>'',
+                                    defined($config_raw{'DEFAULT_sa_bayes_auto_learn'})?('-disabled'=>'1'):());
+               $html =~ s/\@\@\@SPAMASSASSINBAYESAUTOLEARN\@\@\@/$temphtml/;
+            } else {
+               templateblock_disable($html, 'SPAMASSASSINBAYESIAN');
+            }
+
+            if ($config{'sa_local_tests_only'}) {
+               templateblock_disable($html, 'SPAMASSASSINLOCALONLY');
+            } else {
+               templateblock_enable($html, 'SPAMASSASSINLOCALONLY');
+               $temphtml = checkbox(-name=>'sa_use_blacklists',
+                                    -value=>'1',
+                                    -checked=>$prefs{'sa_use_blacklists'},
+                                    -label=>'',
+                                    defined($config_raw{'DEFAULT_sa_use_blacklists'})?('-disabled'=>'1'):());
+               $html =~ s/\@\@\@SPAMASSASSINUSEBLACKLISTS\@\@\@/$temphtml/;
+
+               $temphtml = checkbox(-name=>'sa_use_razor',
+                                    -value=>'1',
+                                    -checked=>$prefs{'sa_use_razor'},
+                                    -label=>'',
+                                    defined($config_raw{'DEFAULT_sa_use_razor'})?('-disabled'=>'1'):());
+               $html =~ s/\@\@\@SPAMASSASSINUSERAZOR\@\@\@/$temphtml/;
+
+               $temphtml = checkbox(-name=>'sa_use_dcc',
+                                    -value=>'1',
+                                    -checked=>$prefs{'sa_use_dcc'},
+                                    -label=>'',
+                                    defined($config_raw{'DEFAULT_sa_use_dcc'})?('-disabled'=>'1'):());
+               $html =~ s/\@\@\@SPAMASSASSINUSEDCC\@\@\@/$temphtml/;
+
+               $temphtml = checkbox(-name=>'sa_use_pyzor',
+                                    -value=>'1',
+                                    -checked=>$prefs{'sa_use_pyzor'},
+                                    -label=>'',
+                                    defined($config_raw{'DEFAULT_sa_use_pyzor'})?('-disabled'=>'1'):());
+               $html =~ s/\@\@\@SPAMASSASSINUSEPYZOR\@\@\@/$temphtml/;
+            }
+
+            $temphtml = checkbox(-name=>'sa_move_spam',
+                                 -value=>'1',
+                                 -checked=>$prefs{'sa_move_spam'},
+                                 -label=>'',
+                                 defined($config_raw{'DEFAULT_sa_move_spam'})?('-disabled'=>'1'):());
+            $html =~ s/\@\@\@SPAMASSASSINMOVESPAM\@\@\@/$temphtml/;
+
+            my (@validfolders, $folderusage, %labels);
+            getfolders(\@validfolders, \$folderusage);
+            foreach (@validfolders, 'DELETE') {
+               if ( defined($lang_folders{$_}) ) {
+                   $labels{$_} = $lang_folders{$_};
+               } else {
+                  $labels{$_} = $_;
+               }
+            }
+            $temphtml = popup_menu(-name=>'sa_spam_destination',
+                                   -values=>[@validfolders, 'DELETE'],
+                                   -default=>$prefs{'sa_spam_destination'} || 'mail-trash',
+                                   -override=>'1',
+                                   -labels=>\%labels,
+                                   defined($config_raw{'DEFAULT_sa_spam_destination'})?('-disabled'=>'1'):());
+            $html =~ s/\@\@\@SPAMASSASSINSPAMDESTINATION\@\@\@/$temphtml/;
+
+            $temphtml = popup_menu(-name=>'sa_score_threshhold',
+                                   -values=>[1..15],
+                                   -labels=>'',
+                                   -default=>$prefs{'sa_score_threshhold'},
+                                   -override=>'1',
+                                   defined($config_raw{'DEFAULT_sa_score_threshhold'})?('-disabled'=>'1'):());
+            $html =~ s/\@\@\@SPAMASSASSINSCORETHRESHHOLD\@\@\@/$temphtml/;
+         } else {
+            templateblock_disable($html, 'SPAMASSASSIN');
+         }
+
+
+
          my @pvalues=(300,320,340,360,380,400,420,440,460,480,500,600,700,800,900,1000);
          my %plabels;
          foreach (@pvalues) {
@@ -1343,9 +1442,18 @@
       showimgaslink 1
       reparagraphorigmsg 1
       backupsentmsg 1
+      filter_badaddrformat 1
       filter_fakedsmtp 1
       filter_fakedfrom 1
       filter_fakedexecontenttype 1
+      sa_enable 1
+      sa_use_bayes 1
+      sa_bayes_auto_learn 1
+      sa_use_blacklists 1
+      sa_use_razor 1
+      sa_use_dcc 1
+      sa_use_pyzor 1
+      sa_move_spam 1
       abook_defaultfilter 1
       calendar_showemptyhours 1
       calendar_reminderforglobal 1
@@ -1449,6 +1557,29 @@
    print SIGNATURE $newprefs{'signature'};
    close (SIGNATURE) or openwebmailerror(__FILE__, __LINE__, "$lang_err{'couldnt_close'} $signaturefile! ($!)");
    chown($uuid, (split(/\s+/,$ugid))[0], $signaturefile) if ($signaturefile eq "$homedir/.signature");
+
+   # save spamassassin_user_prefs
+   if ($config{'enable_spamassassin'}) {
+      my $sa_user_prefs=dotpath('spamassassin_user_prefs');
+      my $sa_configtext = qq|# SpamAssassin config file for version 2.5x\n|.
+                          qq|# generated by $config{'name'} $config{'version'} $config{'releasedate'}\n|.
+                          qq|required_hits   $newprefs{'sa_score_threshhold'}\n|.
+                          qq|use_bayes       $newprefs{'sa_use_bayes'}\n|.
+                          qq|auto_learn      $newprefs{'sa_bayes_auto_learn'}\n|.
+                          qq|skip_rbl_checks $newprefs{'sa_use_blacklists'}\n|.
+                          qq|rbl_timeout     $config{'sa_network_timeout'}\n|.
+                          qq|use_razor2      $newprefs{'sa_use_razor'}\n|.
+                          qq|razor_timeout   $config{'sa_network_timeout'}\n|.
+                          qq|use_dcc         $newprefs{'sa_use_dcc'}\n|.
+                          qq|dcc_timeout     $config{'sa_network_timeout'}\n|.
+                          qq|use_pyzor       $newprefs{'sa_use_pyzor'}\n|.
+                          qq|pyzor_timeout   $config{'sa_network_timeout'}\n|.
+                          qq|clear_headers   1\n|;
+      open (SAPREFS,">$sa_user_prefs") or
+         openwebmailerror(__FILE__, __LINE__, "$lang_err{'couldnt_open'} $sa_user_prefs! ($!)");
+      print SAPREFS $sa_configtext;
+      close (SAPREFS) or openwebmailerror(__FILE__, __LINE__, "$lang_err{'couldnt_close'} $sa_user_prefs! ($!)");
+   }
 
    # save .openwebmailrc
    my $rcfile=dotpath('openwebmailrc');
